import datetime #Para trabajar con fechas.
ultima_id = 0

class Contacto:
    def __init__(self, nombre, celular, direccion='', ciudad='desconocido',
            etiquetas='',fecha_nacimiento=None):
        """Asigna una id consecutiva y recibe el resto de los datos"""
        global ultima_id
        ultima_id+=1
        self.id=ultima_id    
        self.nombre=nombre
        self.celular=celular
        self.direccion=direccion
        self.ciudad=ciudad
        self.etiquetas=etiquetas
        self.fecha_nacimiento=fecha_nacimiento
    
    def coincide(self, filtro):
        """Recibe un filtro (cadena de búsqueda) y retorna True si el nombre, 
        las etiquetas y/o la ciudad contiene el filtro. De lo contrario retorna
        False"""
        #TODO: Implementar el método coincide.
        print("Falta implementar el método coincide")

    def calcular_edad(self):
        """Si la fecha de nacimiento está definida, retorna la edad del 
        contacto. Si la fecha de nacimiento no está definida, retorna None"""
        if not self.fecha_nacimiento:
            # Si self.fecha_nacimiento es None, retorna None:
            return None
        else:
            # TODO: Terminar de implementar el método calcular_edad()
            print("Falta terminar de implementar el método calcular_edad")

    def set_fecha_nacimiento(self, anio, mes, dia):
        """Recibe año, mes, y día y define la fecha de nacimiento"""
        self.fecha_nacimiento = datetime.date(anio, mes, dia)

    def cumple_anios(self, fecha):
        """Recibe una fecha, y retorna True si esa fecha es el cumpleaños del
        contacto, y False de lo contrario."""
        # TODO: Implementar el método cumple_anios()
        print("Falta implementar el método cumple_anios")
    
    def cumple_en(self, lista):
        """Recibe una lista de fechas, y retorna True si alguna de las fechas
        de la lista coincide con el cumpleaños del contacto, y False de lo 
        contrario."""
        # TODO: Implementar el método cumple_en()
        print("Falta implementar el método cumple_en")

    def mostrar(self):
        """Muestra los datos del usuario"""
        # La barra invertida con la n representa un salto de línea.
        cadena = "id: " + str(self.id) + "\n"
        cadena = cadena + "Nombre: "+self.nombre+"\n"
        cadena = cadena + "Celular: "+self.celular+"\n"
        cadena = cadena + "Direccion: "+self.direccion+"\n"
        cadena = cadena + "Ciudad: " +self.ciudad+"\n"
        cadena = cadena + "Etiquetas: "+self.etiquetas+"\n"
        if self.fecha_nacimiento: #(Si fecha_nacimiento *no* es None)
            cadena = (cadena+"Fecha de nacimiento: " 
                + str(self.fecha_nacimiento.day) 
                + "/"+str(self.fecha_nacimiento.month) + "/"
                +str(self.fecha_nacimiento.year) +" \n"
                + "Edad actual: " + str(self.calcular_edad()) +" años.\n")
        else:
            cadena = cadena + "Fecha de nacimiento y edad: Desconocida"
        return cadena
