from contacto import Contacto
import datetime
class Agenda:
    def __init__(self):
        self.contactos=[]

    def nuevo_contacto(self,nombre,celular,direccion='',ciudad='',etiquetas=''):
        """Crea un nuevo objeto contactos y lo agrega a la lista"""
        c = Contacto(nombre, celular, direccion, ciudad, etiquetas)
        self.contactos.append(c)

    def _buscar_por_id(self, id_contacto):
        """Recibe un id de contacto y retorna el contacto que coincide con esa
        id, o None si ninguno de ellos coincide"""
        #TODO: Implementar este método y borrar la siguiente línea:
        print("Falta implementar el método _buscar_por_id")

    def modificar_ciudad(self, id_contacto, ciudad):
        """Recibe un id_contacto y el nombre de una ciudad, y modifica la ciudad
        del contacto que tenga esa id. Retorna True si tiene éxito y False de
        lo contrario"""
        #TODO: Implementar este método y borrar la siguiente línea:
        print("Falta implementar el método modificar_ciudad")

    def modificar_direccion(self, id_contacto, direccion):
        """Recibe un id_contacto y una dirección, y modifica la dirección
        del contacto que tenga esa id. Retorna True si tiene éxito y False de
        lo contrario"""
        #TODO: Implementar este método y borrar la siguiente línea:
        print("Falta implementar el método modificar_direccion")

    def modificar_etiquetas(self, id_contacto, etiquetas):
        """Recibe un id_contacto y una/s etiqueta/s, y modifica las etiquetas
        del contacto que tenga esa id. Retorna True si tiene éxito y False de
        lo contrario"""
        #TODO: Implementar este método y borrar la siguiente línea:
        print("Falta implementar el método modificar_etiquetas")

    def modificar_fecha_nacimiento(self, id_contacto, anio, mes, dia):
        """Recibe un id_contacto, un año, un mes y un día, y modifica la 
        fecha de nacimiento del contacto que tenga esa id. Retorna True si 
        tiene éxito y False de lo contrario"""
        #TODO: Implementar este método y borrar la siguiente línea:
        print("Falta implementar el método modificar_fecha_nacimiento")

    def buscar(self, filtro):
        """Recibe un filtro (cadena de búsqueda), y retorna una lista de todos
        aquellos contactos que coinciden (ver el método "coincide" de la clase
        contactos) con el filtro recibido. Puede retornar una lista vacía"""
        #TODO: Implementar este método y borrar la siguiente línea:
        print("Falta implementar el método buscar")

    def alerta_cumples(self, n):
        """Recibe un número n, y retorna una lista de los contactos que cumplen
        años en los próximos n días (puede retornar una lista vacía)."""
        # Generamos una lista vacía:
        fechas = []
        #Generamos la fecha de hoy
        hoy = datetime.date.today()
        #Hacemos un for en donde "i" va tomando los valores desde 0 hasta "n":
        for i in range(n+1):
            # Generamos una fecha igual a hoy más "i" días...
            f = hoy + datetime.timedelta(days=i)
            # ... y agreamos esa fecha generada a la lista "fechas"
            fechas.append(f)
        # Al salir del "for", la lista "fechas", contiene las fechas de los
        # próximos n días. Ej: si n=2: Tiene las fechas de hoy, mañana y pasado.

        #TODO: Terminar de implementar el método alerta_cumples.
        print("Falta terminar de implementar el método alerta_cumples")
            
            
        
        
